import json
import datetime

def index():
	response.title=T('Exchange Rates')
	return dict()

@request.restful()
def api():
	def GET(*args, **vars):
		if len(args) == 1:
			return db.rates(args[0]).json()
		try:
			year = int(vars['year'])
			month = int(vars['month'])
			day = int(vars['day'])
		except (KeyError, ValueError):
			return db(db.rates).select().json()
			pass
		date = datetime.datetime(year, month, day)
		return db(db.rates.created_datetime.year()==year \
			and db.rates.created_datetime.month()==month \
			and db.rates.created_datetime.day()==day) \
			.select(orderby=db.rates.modified_datetime).json()
		
	def POST(*args, **vars):
		data = json.loads(request.body.read())
		data['created_datetime'] = request.now
		data['modified_datetime'] = request.now
		data['currency'] = data['currency'].upper()
		result = db.rates.validate_and_insert(**data)
		if not result.errors:
			return response.json(data)
		raise HTTP(400, response.json(result.errors))
	def PUT(*args, **vars):
		data = json.loads(request.body.read())
		row = db(db.rates.id==data['id'])
		data['modified_datetime'] = request.now
		result = row.validate_and_update(**data)
		if result.updated:
			return response.json(data)
		return result.errors
	def DELETE(*args, **vars):
		return db(db.rates.id==args[0]).delete()
	return locals()