db = DAL('sqlite://storage.sqlite')

db.define_table('rates',
	Field('country', 'string', length=50, requires=IS_NOT_EMPTY(), label='Country'),
	Field('currency', 'string', length=3, requires=IS_LENGTH(3, 3)),
	Field('unit', 'integer', default=1, requires=IS_INT_IN_RANGE(1, 9999)),
	Field('rate_buy', 'decimal(2,6)', requires=IS_FLOAT_IN_RANGE(0, 9999, dot='.')),
	Field('rate_sell', 'decimal(2,6)', requires=IS_FLOAT_IN_RANGE(0, 9999, dot='.')),
	Field('created_datetime', 'datetime', default=request.now, writable=False),
	Field('modified_datetime', 'datetime', default=request.now))