define(['underscore', 'backbone'], function (_, Backbone) {
	var RateModel = Backbone.Model.extend({
		defaults: {
			country: '',
			currency: '',
			unit: 1,
			rate_buy: 0,
			rate_sell: 0
		},
		urlRoot: 'api'
	});

	var RateCollection = Backbone.Collection.extend({
		model: RateModel,
		url: 'api',
		fetchByDate: function(date) {
			var params = {
				year: date.getFullYear(),
				month: date.getMonth() + 1,
				day: date.getDate()
			};
			this.fetch({ data: $.param(params) });
		}
	});

	return {
		Model: RateModel,
		Collection: RateCollection
	}
});