define(['jquery-ui', 'underscore', 'backbone', 'models/rate',
	'views/rate_form', 'text!templates/menu.html'],
function ($, _, Backbone, Rate, RateFormView, menuTemplate) {
	return Backbone.View.extend({
		events: {
			'click button.new': 'addNew',
			'change .date': 'loadRates'
		},
		initialize: function() {
			this.render();
		},
		render: function() {
			var html = _.template(menuTemplate);
			this.$el.html(html);
			this.$el.find('.date').datepicker({
				constrainInput: true,
				gotoCurrent: true,
				defaultDate: new Date(),
				maxDate: 'now'
			}).datepicker('setDate', new Date());
		},
		addNew: function(e) {
			var model = new Rate.Model();
			var form = new RateFormView({
				el: $('.modal'),
				model: model,
				collection: this.collection
			});
			form.render({ title: 'Add new rate' });
		},
		loadRates: function() {
			var date = this.$el.find('.date').datepicker('getDate');
			window.app.rates.fetchByDate(date);
		}
	});
});