define(['jquery-ui', 'underscore', 'backbone',
	'text!templates/rate_form.html'],
function ($, _, Backbone, formTemplate) {
	return Backbone.View.extend({
		events: {
			'submit form': 'save',
			'click .close': 'close'
		},
		initialize: function() {
			//this.render();
		},
		render: function(params) {
			var model = _.extend(this.model.toJSON(), params);
			var html = _.template(formTemplate, model);
			this.$el.html(html);
			$('.modal').modal('show');
		},
		destroy: function() {
			this.undelegateEvents();
			this.$el.modal('hide');
		},
		save: function(e) {
			e.preventDefault();
			var self = this;
			// serialize and format form data
			var arr = this.$el.find('form').serializeArray();
			var data = {};
			_.each(arr, function (input) {
				data[input.name] = input.value;
			});
			this.model.save(data, {
				wait: true,
				success: function(model, response) {
					self.collection.add(model);
					self.destroy();
				},
				error: function(model, response) {
					alert(response.responseText);
				}
			});
			e.preventDefault();
		},
		close: function(e) {
			this.destroy();
		}
	});
});