define(['jquery-ui', 'underscore', 'backbone',
	'views/rate_form', 'text!templates/rate_row.html'],
function ($, _, Backbone, RateFormView, rowTemplate) {
	return Backbone.View.extend({
		tagName: 'tr',
		className: 'item',
		events: {
			'click .edit': 'edit',
			'click .delete': 'delete'
		},
		initialize: function() {
			this.model.on('change', function () {
				this.render();
			}, this);
			this.render();
		},
		render: function() {
			var html = _.template(rowTemplate, this.model.toJSON());
			this.$el.html(html);
		},
		delete: function(e) {
			if (!confirm('Are you shure you want to delete this rate?')) {
				return;
			}
			this.model.destroy({
				success: function() {
				},
				error: function(model, response) {
					alert(response.responseText);
				}
			});
		},
		edit: function(e) {
			var form = new RateFormView({
				el: $('.modal'),
				model: this.model,
				collection: this.collection
			});
			form.render({ title: 'Edit currency' });
		}
	});
});