define(['jquery-ui', 'underscore', 'backbone', 'views/rate_row',
	'text!templates/rate_table.html', 'text!templates/message_row.html'],
function ($, _, Backbone, RateRowView, tableTemplate, messageTemplate) {
	return Backbone.View.extend({
		initialize: function() {
			this.collection.on('reset remove change add', function () {
				this.render();
			}, this);
		},
		render: function() {
			var self = this;
			var html = _.template(tableTemplate);
			this.$el.html(html);

			if (!this.collection.length) {
				var html = _.template(messageTemplate, {
					message: 'no data for selected date'
				});
				this.$el.find('tbody').html(html);
				return;
			}

			this.collection.each(function(model) {
				var row = new RateRowView({
					model: model,
					collection: self.collection
				});
				self.$el.find('tbody').prepend(row.$el);
			});
		}
	});
});